use serde::{Deserialize, Serialize};
use std::collections::HashMap;

#[derive(Debug, Serialize, Deserialize)]
pub struct DockerCompose {
    pub version: Option<String>,
    pub services: HashMap<String, Service>,
    pub volumes: Option<HashMap<String, Volume>>,
}

#[derive(Debug, Serialize, Deserialize)]
pub struct Service {
    pub image: Option<String>,
    pub container_name: Option<String>,
    pub build: Option<Build>,
    pub ports: Option<Vec<String>>,
    pub volumes: Option<Vec<String>>,
    pub environment: Option<HashMap<String, String>>,
    pub depends_on: Option<Vec<String>>,
    pub auto_remove: Option<bool>,
    pub restart: Option<String>,
}

#[derive(Debug, Serialize, Deserialize)]
pub struct Build {
    pub context: Option<String>,
    pub dockerfile: Option<String>,
}

#[derive(Debug, Serialize, Deserialize)]
pub struct Volume {
    pub driver: Option<String>,
    pub driver_opts: Option<HashMap<String, String>>,
    pub labels: Option<HashMap<String, String>>,
}
